package test;

import java.io.InputStream;
import java.io.IOException;


abstract public class OptLayoutImpl extends PeanoConstructor
{
  static OptLayout fromString(String str)
  {
    aterm.ATerm trm = getStaticPeanoFactory().parse(str);
    return fromTerm(trm);
  }

  static OptLayout fromTextFile(InputStream stream) throws aterm.ParseError, IOException
  {
    aterm.ATerm trm = getStaticPeanoFactory().readFromTextFile(stream);
    return fromTerm(trm);
  }

  public boolean isEqual(OptLayout peer)
  {
    return term.isEqual(peer.toTerm());
  }

  public static OptLayout fromTerm(aterm.ATerm trm)
  {
    OptLayout tmp;
    if ((tmp = OptLayout_Absent.fromTerm(trm)) != null) {
      return tmp;
    }

    if ((tmp = OptLayout_Present.fromTerm(trm)) != null) {
      return tmp;
    }


    throw new RuntimeException("This is not a OptLayout: " + trm);
  }


  public boolean isAbsent()
  {
    return false;
  }

  public boolean isPresent()
  {
    return false;
  }

  public boolean hasChars()
  {
    return false;
  }


  public CHARLIST getChars()
  {
     throw new RuntimeException("This OptLayout has no Chars");
  }

  public OptLayout setChars(CHARLIST _chars)
  {
     throw new RuntimeException("This OptLayout has no Chars");
  }



}

